package body Bitmap_Routines is

   Header_Bytes : constant Length_Type := 14 + 40;

   function Get_Nb_Of_Row_Colour_Bytes (Rec : Rectangele_Type) return Length_Type is
      Length    : Length_Type;
      Remainder : Int32_T;
   begin
      Length    := 3 * Rec.Width;
      Remainder := Length rem 4;

      if Remainder > 0 then
         Length := Length + (4 - Remainder);
      end if;

      pragma Assert (Length rem 4 = 0, "Incorrect line length");

      return Length;
   end Get_Nb_Of_Row_Colour_Bytes;

   -- -- --

   function Get_Nb_Of_All_Bytes (Rec : Rectangele_Type) return Length_Type is
      Length    : Length_Type;
      Remainder : Int32_T;
   begin
      Length := Rec.Height * Get_Nb_Of_Row_Colour_Bytes (Rec) + Header_Bytes;

      return Length;
   end Get_Nb_Of_All_Bytes;

   -- -- --

   function Get_Nb_Of_All_Colour_Bytes (Rec : Rectangele_Type) return Length_Type is
   begin
      return Get_Nb_Of_All_Bytes (Rec) - Header_Bytes;
   end Get_Nb_Of_All_Colour_Bytes;

   -- -- --

end Bitmap_Routines;
