--

with Ada.Numerics.Discrete_Random;

package body Coloured_Images is
   use Ada.Numerics;

   package Random_Colours is new Discrete_Random (Colour_Value_Type);

   -- -- --

   procedure Fill_With_Random_Colour (Seg : in Sci.Segment_Record_Type) is
      --
      Gr : Random_Colours.Generator;
      Gg : Random_Colours.Generator;
      Gb : Random_Colours.Generator;

      My_Segment : Sci.Segment_Type renames Seg.M (Seg.I, Seg.K);
   begin
      Random_Colours.Reset (Gr);
      Random_Colours.Reset (Gg);
      Random_Colours.Reset (Gb);

      for Ix in Inner_Index_Type loop
         for Kx in Inner_Index_Type loop

            My_Segment (Ix, Kx).R := Random_Colours.Random (Gr);
            My_Segment (Ix, Kx).G := Random_Colours.Random (Gg);
            My_Segment (Ix, Kx).B := Random_Colours.Random (Gb);

         end loop;
      end loop;

   end Fill_With_Random_Colour;

   -- -- --

   function Fill_With_Random_Colour
     (Seg : in Sci.Segment_Record_Type) return Sci.Segment_Record_Type is
   begin
      Fill_With_Random_Colour (Seg);

      return Seg;
   end Fill_With_Random_Colour;

end Coloured_Images;
