--

with Segmented_Matrices;

package Coloured_Images is

   type Colour_Value_Type is range 0 .. 255 with
        Size => 8;

   type Colour_Record_Type is record
      B : Colour_Value_Type := 0;
      G : Colour_Value_Type := 0;
      R : Colour_Value_Type := 0;
      --
      -- N : Colour_Value_Type := 0; -- Always 0
   end record;

   for Colour_Record_Type use record
      B at 0 range  0 ..  7;
      G at 0 range  8 .. 15;
      R at 0 range 16 .. 23;
      --
      -- N at 0 range 24 .. 31;
   end record;

   -- -- --

   type Inner_Index_Type is range 1 .. 2**12; -- 2**12 <= ok
   type Outer_Index_Type is range 1 .. 4;
--

   package Segmented_Coloured_Images is new Segmented_Matrices
     (Inner_Index_Type => Inner_Index_Type,
      Outer_Index_Type => Outer_Index_Type,
      Element_Type     => Colour_Record_Type);

   package Sci renames Segmented_Coloured_Images;

   -- -- --

   procedure Fill_With_Random_Colour (Seg : in Sci.Segment_Record_Type);

   function Fill_With_Random_Colour
     (Seg : in Sci.Segment_Record_Type) return Sci.Segment_Record_Type;

end Coloured_Images;
